﻿using System;
using System.Runtime.InteropServices;

namespace Ekey.EkeyNet.Sdk
{
	public enum Answer : Int32
	{
		NoData = -1,
		Error = 0,
		Cmd = 1,
		Respone = 2
	}

	public enum Command : byte
	{
		Logon = 0,
		Logoff,
		ReadUser,
		AddUser,
		ModifyUser,
		DeleteUser,
		AddUserToGroup,
		RemoveUserFromGroup,
		AddUserToCommonGroup,
		RemoveUserFromCommonGroup,
		ReadGroups,
		ReadGroup,
		AddGroup,
		DeleteGroup,
		RenameGroup,
		AddTimezone,
		ReadTimezone,
		ReadTimezones,
		EnableRcvNotify,
		DisableRcvNotify,
		NotifyUser,
		NotifyTerminal,
		NotifySave,
		SendData,
		GetChangeCount
	}

	public enum Error : byte
	{
		Success,
		Failure,
		NoLogin,
		Exists,
		Missing,
		NotAllowed,
		Unknown,
		InvalidDataVersion
	}

	public enum Field : Int32
	{
		Cmd = 0,
		Answer,
		LogonName,
		LogonPwd,
		Version,
		Company,
		ObjectID,
		Name,
		Firstname,
		Lastname,
		// 10 unused
		Description = 11,
		State,
		Fingermask,
		Finger0,
		Finger1,
		Finger2,
		Finger3,
		Finger4,
		Finger5,
		Finger6,
		Finger7,
		Finger8,
		Finger9,
		TimeFinger0,
		TimeFinger1,
		TimeFinger2,
		TimeFinger3,
		TimeFinger4,
		TimeFinger5,
		TimeFinger6,
		TimeFinger7,
		TimeFinger8,
		TimeFinger9,
		ValidFrom,
		ValidTo,
		Photo,
		PersonalID,
		Email,
		Phone,
		Phone2,
		Address,
		Title,
		Position,
		Department,
		Supervisor,
		Assistant,
		Userdef1,
		Userdef2,
		Userdef3,
		Userdef4,
		Userdef5,
		Userdef6,
		Userdef7,
		Userdef8,
		Userdef9,
		Userdef10,
		Wiegand,
		Rfid,
		Usergroup,
		Usergroup2,
		Usergroups,
		UsersInGroup,
		Timezone,
		Timezones,
		TimezoneData,
		ChangeCount,
		TemplateType
	}

	class EkeyNetSdkWrapper
	{
		[DllImport("ekeynetsdk.dll", EntryPoint = "Connect", CallingConvention = CallingConvention.StdCall)]
		public static extern int Connect();

		[DllImport("ekeynetsdk.dll", EntryPoint = "IsConnected", CallingConvention = CallingConvention.StdCall)]
		public static extern int IsConnected();

		[DllImport("ekeynetsdk.dll", EntryPoint = "Disconnect", CallingConvention = CallingConvention.StdCall)]
		public static extern void Disconnect();

		[DllImport("ekeynetsdk.dll", EntryPoint = "Logon", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
		public static extern int Logon(string user, string pwd);

		[DllImport("ekeynetsdk.dll", EntryPoint = "Logoff", CallingConvention = CallingConvention.StdCall)]
		public static extern int Logoff();

		[DllImport("ekeynetsdk.dll", EntryPoint = "ekeynet_SetField", CallingConvention = CallingConvention.StdCall)]
		public static extern int SetField(int fieldNumber, IntPtr pData, int length);

		[DllImport("ekeynetsdk.dll", EntryPoint = "ekeynet_Write", CallingConvention = CallingConvention.StdCall)]
		public static extern int Write();

		[DllImport("ekeynetsdk.dll", EntryPoint = "ekeynet_GetField", CallingConvention = CallingConvention.StdCall)]
		public static extern int GetField(int fieldNumber, IntPtr pData, int length);

		[DllImport("ekeynetsdk.dll", EntryPoint = "ekeynet_Read", CallingConvention = CallingConvention.StdCall)]
		public static extern int Read();

		[DllImport("ekeynetsdk.dll", EntryPoint = "TypeToString", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
		public static extern IntPtr TypeToString(int ekeyNetSdkType);
		// Aufruf: string type = Marshal.PtrToStringUni(EkeyNetSdkWrapper.TypeToString(1));

		[DllImport("ekeynetsdk.dll", EntryPoint = "CommandToString", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
		public static extern IntPtr CommandToString(byte ekeyNetSdkCmd);
		// Aufruf: string cmd = Marshal.PtrToStringUni(EkeyNetSdkWrapper.CommandToString(1));

		[DllImport("ekeynetsdk.dll", EntryPoint = "AnswerTypeToString", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
		public static extern IntPtr AnswerTypeToString(int ekeyNetSdkDataType);
		// Aufruf: string answer = Marshal.PtrToStringUni(EkeyNetSdkWrapper.AnswerTypeToString(1));

		[DllImport("ekeynetsdk.dll", EntryPoint = "ErrorToString", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
		public static extern IntPtr ErrorToString(byte ekeyNetSdkError);
		// Aufruf: string error = Marshal.PtrToStringUni(EkeyNetSdkWrapper.ErrorToString(1));

		[DllImport("ekeynetsdk.dll", EntryPoint = "FieldToString", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
		public static extern IntPtr FieldToString(int ekeyNetSdkField);
		// Aufruf: string field = Marshal.PtrToStringUni(EkeyNetSdkWrapper.FieldToString(1));
	}
}
