#ifndef EKEY_NET_SDK_H_
#define EKEY_NET_SDK_H_

#include "ekeynetsdkdefs.h"

#ifdef __cplusplus
extern "C"
{
#endif

int PASCAL Connect();
int PASCAL IsConnected();
void PASCAL Disconnect();
int PASCAL Logon(const wchar_t* user, const wchar_t* pwd);
int PASCAL Logoff();
int PASCAL ekeynet_SetField(int nFieldNo, const void* p, int nBytes);
int PASCAL ekeynet_Write(void);
int PASCAL ekeynet_GetField(int nFieldNo, void* p, int nMaxBytes);
int PASCAL ekeynet_Read(void);

//Helper
const wchar_t* PASCAL TypeToString(int ekeyNetSdkType);
const wchar_t* PASCAL CommandToString(BYTE ekeyNetSdkCmd);
const wchar_t* PASCAL AnswerTypeToString(int ekeyNetSdkDataType);
const wchar_t* PASCAL ErrorToString(BYTE ekeyNetSdkError);
const wchar_t* PASCAL FieldToString(int ekeyNetSdkField);



#ifdef __cplusplus
}
#endif

#endif //EKEY_NET_SDK_H_
