#ifndef _EKEY_NET_SDK_DEFS_H_
#define _EKEY_NET_SDK_DEFS_H_


#define EKEY_NET_MAX_ARRAY_SIZE 10000


#define EKEY_NET_INT                 0
#define EKEY_NET_UINT                1
#define EKEY_NET_STRING              2
#define EKEY_NET_BYTE                3
#define EKEY_NET_BOOL                4
#define EKEY_NET_MASK                5
#define EKEY_NET_SYSTEMTIME          6
#define EKEY_NET_ARRAY               7
#define EKEY_NET_UINT64              8
#define EKEY_NET_STRINGLIST          9
#define EKEY_NET_UINTARRAY           10


#define EKEY_NET_CMD_LOGON                      0
#define EKEY_NET_CMD_LOGOFF                     1
#define EKEY_NET_CMD_READUSER                   2
#define EKEY_NET_CMD_ADDUSER                    3
#define EKEY_NET_CMD_MODIFYUSER                 4
#define EKEY_NET_CMD_DELETEUSER                 5
#define EKEY_NET_CMD_ADDUSERTOGROUP             6
#define EKEY_NET_CMD_REMOVEUSERFROMGROUP        7
#define EKEY_NET_CMD_ADDUSERTOCOMMONGROUP       8
#define EKEY_NET_CMD_REMOVEUSERFROMCOMMONGROUP  9
#define EKEY_NET_CMD_READGROUPS                10
#define EKEY_NET_CMD_READGROUP                 11
#define EKEY_NET_CMD_ADDGROUP                  12
#define EKEY_NET_CMD_DELETEGROUP               13
#define EKEY_NET_CMD_RENAMEGROUP               14
#define EKEY_NET_CMD_ADDTIMEWINDOW             15
#define EKEY_NET_CMD_READTIMEWINDOW            16
#define EKEY_NET_CMD_READTIMEWINDOWS           17
#define EKEY_NET_CMD_ENABLERCVNOTIFY           18
#define EKEY_NET_CMD_DISABLERCVNOTIFY          19
#define EKEY_NET_CMD_NOTIFYUSER                20
#define EKEY_NET_CMD_NOTIFYTERMINAL            21
#define EKEY_NET_CMD_NOTIFYSAVE                22
#define EKEY_NET_CMD_SENDDATA                  23
#define EKEY_NET_CMD_GETCHANGECNT              24


#define EKEY_NET_SDK_ANSWER_NO_DATA       -1
#define EKEY_NET_SDK_ANSWER_ERROR          0
#define EKEY_NET_SDK_ANSWER_CMD            1
#define EKEY_NET_SDK_ANSWER_RESPONSE       2


#define EKEY_NET_EC_NOERROR              0
#define EKEY_NET_EC_FAILED               1
#define EKEY_NET_EC_NOLOGIN              2
#define EKEY_NET_EC_EXISTS               3
#define EKEY_NET_EC_MISSING              4
#define EKEY_NET_EC_NOTALLOWED           5
#define EKEY_NET_EC_UNKNOWN              6
#define EKEY_NET_EC_INVALID_DATA_VERSION 7


#define EKEY_NET_FIELD_CMD            0
#define EKEY_NET_FIELD_ANSWER         1
#define EKEY_NET_FIELD_LOGON          2
#define EKEY_NET_FIELD_LOGONPWD       3
#define EKEY_NET_FIELD_VERSION        4
#define EKEY_NET_FIELD_COMPANY        5
#define EKEY_NET_FIELD_OBJECTID       6
#define EKEY_NET_FIELD_NAME           7
#define EKEY_NET_FIELD_FIRSTNAME      8
#define EKEY_NET_FIELD_LASTNAME       9

#define EKEY_NET_FIELD_DESC          11
#define EKEY_NET_FIELD_STATE         12
#define EKEY_NET_FIELD_FINGERMASK    13
#define EKEY_NET_FIELD_FINGER0       14
#define EKEY_NET_FIELD_FINGER1       15
#define EKEY_NET_FIELD_FINGER2       16
#define EKEY_NET_FIELD_FINGER3       17
#define EKEY_NET_FIELD_FINGER4       18
#define EKEY_NET_FIELD_FINGER5       19
#define EKEY_NET_FIELD_FINGER6       20
#define EKEY_NET_FIELD_FINGER7       21
#define EKEY_NET_FIELD_FINGER8       22
#define EKEY_NET_FIELD_FINGER9       23
#define EKEY_NET_FIELD_TIMEFINGER0   24
#define EKEY_NET_FIELD_TIMEFINGER1   25
#define EKEY_NET_FIELD_TIMEFINGER2   26
#define EKEY_NET_FIELD_TIMEFINGER3   27
#define EKEY_NET_FIELD_TIMEFINGER4   28
#define EKEY_NET_FIELD_TIMEFINGER5   29
#define EKEY_NET_FIELD_TIMEFINGER6   30
#define EKEY_NET_FIELD_TIMEFINGER7   31
#define EKEY_NET_FIELD_TIMEFINGER8   32
#define EKEY_NET_FIELD_TIMEFINGER9   33
#define EKEY_NET_FIELD_VALIDFROM     34
#define EKEY_NET_FIELD_VALIDTO       35
#define EKEY_NET_FIELD_PHOTO         36
#define EKEY_NET_FIELD_PERSONALID    37
#define EKEY_NET_FIELD_EMAIL         38
#define EKEY_NET_FIELD_TELEPHONE     39
#define EKEY_NET_FIELD_TELEPHONE2    40
#define EKEY_NET_FIELD_ADDRESS       41
#define EKEY_NET_FIELD_TITLE         42
#define EKEY_NET_FIELD_POSITION      43
#define EKEY_NET_FIELD_DEPARTMENT    44
#define EKEY_NET_FIELD_SUPERVISOR    45
#define EKEY_NET_FIELD_ASSISTANT     46
#define EKEY_NET_FIELD_USERDEFINED1  47
#define EKEY_NET_FIELD_USERDEFINED2  48
#define EKEY_NET_FIELD_USERDEFINED3  49
#define EKEY_NET_FIELD_USERDEFINED4  50
#define EKEY_NET_FIELD_USERDEFINED5  51
#define EKEY_NET_FIELD_USERDEFINED6  52
#define EKEY_NET_FIELD_USERDEFINED7  53
#define EKEY_NET_FIELD_USERDEFINED8  54
#define EKEY_NET_FIELD_USERDEFINED9  55
#define EKEY_NET_FIELD_USERDEFINED10 56
#define EKEY_NET_FIELD_WIEGANDID     57
#define EKEY_NET_FIELD_RFID          58
#define EKEY_NET_FIELD_USERGROUP     59
#define EKEY_NET_FIELD_USERGROUP2    60
#define EKEY_NET_FIELD_USERGROUPS     61
#define EKEY_NET_FIELD_USERSINGROUP   62
#define EKEY_NET_FIELD_TIMEWINDOW     63
#define EKEY_NET_FIELD_TIMEWINDOWS    64
#define EKEY_NET_FIELD_TIMEWINDOWDATA 65
#define EKEY_NET_FIELD_CHANGECNT      66
#define EKEY_NET_FIELD_TEMPLATE_TYPE  67


#endif //_EKEY_NET_SDK_DEFS_H_