#include "stdafx.h"
#include "aboutdlg.h"

#pragma comment (lib, "Version.lib")

#ifdef _DEBUG
	#define new DEBUG_NEW
#endif

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD), m_staticVersion()
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_VERSION, m_staticVersion);
}

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString str;

	wchar_t szPath[MAX_PATH] = { 0 };
	if (GetModuleFileName(nullptr, szPath, MAX_PATH))
	{
		CString fileName = szPath;
		str.Format(L"ekey net sdk sample Dateiversion:%s", CAboutDlg::GetFileVersionFromFile(fileName));
		m_staticVersion.SetWindowText(str);
	}

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

CString CAboutDlg::GetFileVersionFromFile(const CString& fileName)
{
	CString fileVersion;

	if (fileName.IsEmpty())
	{
		return fileVersion;
	}
	DWORD dwDummy = 0;
	DWORD size = GetFileVersionInfoSizeEx(0, fileName.GetString(), &dwDummy);
	if (0 == size)
	{
		return fileVersion;
	}
	CByteArray data;
	data.SetSize(size);
	if (!GetFileVersionInfoEx(0, fileName.GetString(), 0, size, data.GetData()))
	{
		return fileVersion;
	}
	VS_FIXEDFILEINFO* pFileInfo = nullptr;
	UINT lenFileInfo = 0;
	if (!VerQueryValue(data.GetData(), L"\\", (LPVOID*)&pFileInfo, &lenFileInfo))
	{
		return fileVersion;
	}
	if (lenFileInfo != sizeof(VS_FIXEDFILEINFO))
	{
		return fileVersion;
	}
	fileVersion.Format(L"%u.%u.%u.%u", HIWORD(pFileInfo->dwFileVersionMS), LOWORD(pFileInfo->dwFileVersionMS), HIWORD(pFileInfo->dwFileVersionLS), LOWORD(pFileInfo->dwFileVersionLS));
	return fileVersion;
}