#include "stdafx.h"
#include "ekeynetsdksampledlg.h"
#include "aboutdlg.h"

#ifdef _DEBUG
	#define new DEBUG_NEW
#endif

const unsigned DefaultTimerTimeout = 50u;
const UINT_PTR DefaultTimerID = 1;

const int DefaultBorder = 10;
const int DefaultSmallBorder = 5;
const int DefaultVerySmallBorder = 2;

EkeyNetSdkSampleDlg::EkeyNetSdkSampleDlg(CWnd* pParent /*=NULL*/) : CDialog(EkeyNetSdkSampleDlg::IDD, pParent)
	, m_hIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME)), m_buffer(), m_order(), m_list(), m_timerID(0), m_editUserName(), m_editPwd()
	, m_staticDisplayName(), m_editDisplayName(), m_staticFirstName(), m_editFirstName(), m_staticLastName(), m_editLastName()
	, m_staticDescription(), m_editDescription(), m_staticOid(), m_editOid(), m_staticPath(), m_editPath()
	, m_staticNewName(), m_editNewName(), m_staticPersonalID(), m_editPersonalID(), m_staticCompany(), m_editCompany()
{
}

EkeyNetSdkSampleDlg::~EkeyNetSdkSampleDlg()
{
	Disconnect();
}

void EkeyNetSdkSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ORDER, m_order);
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Control(pDX, IDC_EDIT_USER_NAME, m_editUserName);
	DDX_Control(pDX, IDC_EDIT_PWD, m_editPwd);
	DDX_Control(pDX, IDC_STATIC_DISPLAY_NAME, m_staticDisplayName);
	DDX_Control(pDX, IDC_EDIT_DISPLAY_NAME, m_editDisplayName);
	DDX_Control(pDX, IDC_STATIC_FIRST_NAME, m_staticFirstName);
	DDX_Control(pDX, IDC_EDIT_FIRST_NAME, m_editFirstName);
	DDX_Control(pDX, IDC_STATIC_LAST_NAME, m_staticLastName);
	DDX_Control(pDX, IDC_EDIT_LAST_NAME, m_editLastName);
	DDX_Control(pDX, IDC_STATIC_DESC, m_staticDescription);
	DDX_Control(pDX, IDC_EDIT_DESC, m_editDescription);
	DDX_Control(pDX, IDC_STATIC_OID, m_staticOid);
	DDX_Control(pDX, IDC_EDIT_OID, m_editOid);
	DDX_Control(pDX, IDC_STATIC_PATH, m_staticPath);
	DDX_Control(pDX, IDC_EDIT_PATH, m_editPath);
	DDX_Control(pDX, IDC_STATIC_NEW_NAME, m_staticNewName);
	DDX_Control(pDX, IDC_EDIT_NEW_NAME, m_editNewName);
	DDX_Control(pDX, IDC_STATIC_PERSONAL_ID, m_staticPersonalID);
	DDX_Control(pDX, IDC_EDIT_PERSONAL_ID, m_editPersonalID);
	DDX_Control(pDX, IDC_STATIC_COMPANY, m_staticCompany);
	DDX_Control(pDX, IDC_EDIT_COMPANY, m_editCompany);
}

BEGIN_MESSAGE_MAP(EkeyNetSdkSampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_TIMER()
END_MESSAGE_MAP()


BOOL EkeyNetSdkSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Hinzufgen des Menbefehls "Info..." zum Systemmen.
	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		   // Kleines Symbol verwenden
	CRect r, rDlg;
	m_list.GetClientRect(&r);
	m_list.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP | LVS_EX_LABELTIP);
	m_list.InsertColumn(0, _T("Time"), LVCFMT_LEFT, 120);
	m_list.InsertColumn(1, _T(""), LVCFMT_LEFT, r.Width() - 120 - GetSystemMetrics(SM_CXVSCROLL));

	int index = m_order.AddString(_T("Logon"));
	m_order.SetItemData(index, EKEY_NET_CMD_LOGON);

	index = m_order.AddString(_T("Logoff"));
	m_order.SetItemData(index, EKEY_NET_CMD_LOGOFF);

	index = m_order.AddString(_T("Read user"));
	m_order.SetItemData(index, EKEY_NET_CMD_READUSER);

	index = m_order.AddString(_T("Add user"));
	m_order.SetItemData(index, EKEY_NET_CMD_ADDUSER);

	index = m_order.AddString(_T("Modify user"));
	m_order.SetItemData(index, EKEY_NET_CMD_MODIFYUSER);

	index = m_order.AddString(_T("Delete user"));
	m_order.SetItemData(index, EKEY_NET_CMD_DELETEUSER);

	index = m_order.AddString(_T("Add user to group"));
	m_order.SetItemData(index, EKEY_NET_CMD_ADDUSERTOGROUP);

	index = m_order.AddString(_T("Remove user from group"));
	m_order.SetItemData(index, EKEY_NET_CMD_REMOVEUSERFROMGROUP);

	index = m_order.AddString(_T("Add user to common group"));
	m_order.SetItemData(index, EKEY_NET_CMD_ADDUSERTOCOMMONGROUP);

	index = m_order.AddString(_T("Remove user from common group"));
	m_order.SetItemData(index, EKEY_NET_CMD_REMOVEUSERFROMCOMMONGROUP);

	index = m_order.AddString(_T("Read groups"));
	m_order.SetItemData(index, EKEY_NET_CMD_READGROUPS);

	index = m_order.AddString(_T("Read group"));
	m_order.SetItemData(index, EKEY_NET_CMD_READGROUP);

	index = m_order.AddString(_T("Add group"));
	m_order.SetItemData(index, EKEY_NET_CMD_ADDGROUP);

	index = m_order.AddString(_T("Delete group"));
	m_order.SetItemData(index, EKEY_NET_CMD_DELETEGROUP);

	index = m_order.AddString(_T("Rename group"));
	m_order.SetItemData(index, EKEY_NET_CMD_RENAMEGROUP);

	index = m_order.AddString(_T("Add time window"));
	m_order.SetItemData(index, EKEY_NET_CMD_ADDTIMEWINDOW);

	index = m_order.AddString(_T("Read time window"));
	m_order.SetItemData(index, EKEY_NET_CMD_READTIMEWINDOW);

	index = m_order.AddString(_T("Read time windows"));
	m_order.SetItemData(index, EKEY_NET_CMD_READTIMEWINDOWS);

	index = m_order.AddString(_T("Enable notify"));
	m_order.SetItemData(index, EKEY_NET_CMD_ENABLERCVNOTIFY);

	index = m_order.AddString(_T("Disable notify"));
	m_order.SetItemData(index, EKEY_NET_CMD_DISABLERCVNOTIFY);

	index = m_order.AddString(_T("Update user data on all devices"));
	m_order.SetItemData(index, EKEY_NET_CMD_SENDDATA);

	index = m_order.AddString(_T("Get Change Count"));
	m_order.SetItemData(index, EKEY_NET_CMD_GETCHANGECNT);
	m_order.SetCurSel(0);
	CenterWindow();
	m_timerID = SetTimer(DefaultTimerID, DefaultTimerTimeout, nullptr);
	if (!Connect())
	{
		AfxMessageBox(_T("Error connecting to ekey net master server"), MB_ICONERROR);
		PostMessage(WM_COMMAND, IDCANCEL);
	}
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void EkeyNetSdkSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.
void EkeyNetSdkSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen
		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR EkeyNetSdkSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void EkeyNetSdkSampleDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	if (cx && m_list.GetSafeHwnd())
	{
		CRect rCli;
		GetClientRect(&rCli);

		CRect rCombo;
		m_order.GetWindowRect(&rCombo);
		ScreenToClient(&rCombo);

		CRect rStatic;
		m_staticDisplayName.GetWindowRect(&rStatic);
		ScreenToClient(&rStatic);

		CRect rEdit;
		m_editDisplayName.GetWindowRect(&rEdit);
		ScreenToClient(&rEdit);

		int xEdit = rCli.right - rEdit.Width() - DefaultBorder;
		int y = rCli.top + 2 * DefaultBorder + rCombo.Height();
		m_editDisplayName.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		int xStatic = xEdit - rStatic.Width();
		m_staticDisplayName.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editFirstName.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticFirstName.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editLastName.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticLastName.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editDescription.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticDescription.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editOid.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticOid.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editPath.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticPath.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editNewName.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticNewName.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editPersonalID.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticPersonalID.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		y += DefaultVerySmallBorder + rEdit.Height();
		m_editCompany.SetWindowPos(NULL, xEdit, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
		m_staticCompany.SetWindowPos(NULL, xStatic, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

		m_list.SetWindowPos(NULL, 0, 0, xStatic - 2 * DefaultBorder, rCli.Height() - rCombo.Height() - DefaultSmallBorder - 2 * DefaultBorder, SWP_NOZORDER | SWP_NOMOVE);
	}
}

void EkeyNetSdkSampleDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == m_timerID)
	{
		int nRet = ekeynet_Read();
		if (nRet == EKEY_NET_SDK_ANSWER_NO_DATA)
		{
			return;      // no data available
		}
		if (nRet == EKEY_NET_SDK_ANSWER_ERROR)
		{
			// handle error
			KillTimer(m_timerID);
			m_timerID = 0;
			AfxMessageBox(_T("Error reading from ekey net master server"), MB_ICONERROR);
			PostMessage(WM_COMMAND, IDCANCEL);
			return;
		}
		if (nRet == EKEY_NET_SDK_ANSWER_RESPONSE)
		{
			CStringList list;
			BYTE cCmd, cAnswer;
			ekeynet_GetField(EKEY_NET_FIELD_CMD, &cCmd, sizeof(cCmd));
			ekeynet_GetField(EKEY_NET_FIELD_ANSWER, &cAnswer, sizeof(cAnswer));
			FieldContentToStrings(EKEY_NET_FIELD_ANSWER, list);
			CString str;
			str.Format(_T("Got response to cmd %s %s"), CommandToString(cCmd), list.GetHead());
			AddLine(str);
			if (cAnswer == EKEY_NET_EC_NOERROR)
			{
				switch (cCmd)
				{
				case EKEY_NET_CMD_ADDUSER:
				case EKEY_NET_CMD_READUSER:
					//AddFieldLine(EKEY_NET_FIELD_COMPANY);
					AddFieldLine(EKEY_NET_FIELD_OBJECTID);
					AddFieldLine(EKEY_NET_FIELD_NAME);
					AddFieldLine(EKEY_NET_FIELD_FIRSTNAME);
					AddFieldLine(EKEY_NET_FIELD_LASTNAME);
					AddFieldLine(EKEY_NET_FIELD_DESC);
					return;
				case EKEY_NET_CMD_READGROUPS:
					AddFieldLine(EKEY_NET_FIELD_USERGROUPS);
					return;
				case EKEY_NET_CMD_READGROUP:
					AddFieldLine(EKEY_NET_FIELD_USERGROUP);
					AddFieldLine(EKEY_NET_FIELD_DESC);
					AddFieldLine(EKEY_NET_FIELD_USERSINGROUP);
					return;
				case EKEY_NET_CMD_READTIMEWINDOWS:
					AddFieldLine(EKEY_NET_FIELD_TIMEWINDOWS);
					return;
				case EKEY_NET_CMD_READTIMEWINDOW:
					AddFieldLine(EKEY_NET_FIELD_TIMEWINDOW);
					AddFieldLine(EKEY_NET_FIELD_TIMEWINDOWDATA);
					return;
				case EKEY_NET_CMD_ADDTIMEWINDOW:
					AddFieldLine(EKEY_NET_FIELD_TIMEWINDOW);
					return;
				case EKEY_NET_CMD_ADDGROUP:
					AddFieldLine(EKEY_NET_FIELD_USERGROUP);
					return;
				case EKEY_NET_CMD_SENDDATA:
					return;
				case EKEY_NET_CMD_GETCHANGECNT:
					AddFieldLine(EKEY_NET_FIELD_CHANGECNT);
					return;
				}
			}
		}
		else if (nRet == EKEY_NET_SDK_ANSWER_CMD)
		{
			CStringList list;
			BYTE cCmd, cAnswer;
			ekeynet_GetField(EKEY_NET_FIELD_CMD, &cCmd, sizeof(cCmd));
			ekeynet_GetField(EKEY_NET_FIELD_ANSWER, &cAnswer, sizeof(cAnswer));
			FieldContentToStrings(EKEY_NET_FIELD_ANSWER, list);
			CString str;
			str.Format(_T("Got notification %s %s"), CommandToString(cCmd), list.GetHead());
			AddLine(str);
			if (cAnswer == EKEY_NET_EC_NOERROR)
			{
				switch (cCmd)
				{
				case EKEY_NET_CMD_NOTIFYUSER:
					AddFieldLine(EKEY_NET_FIELD_USERSINGROUP);
					return;
				case EKEY_NET_CMD_NOTIFYTERMINAL:
				case EKEY_NET_CMD_NOTIFYSAVE:
					return;
				}
			}
		}
		return;
	}
	CDialog::OnTimer(nIDEvent);
}

void EkeyNetSdkSampleDlg::AddLine(CString str, BOOL bShowTime)
{
	COleDateTime t = COleDateTime::GetCurrentTime();
	int nItem = m_list.InsertItem(m_list.GetItemCount(), (bShowTime) ? t.Format() : _T(""));
	m_list.SetItemText(nItem, 1, str);
	m_list.EnsureVisible(nItem, FALSE);
}

void EkeyNetSdkSampleDlg::AddFieldLine(int nFieldNo)
{
	int nLine = 0;
	CStringList list;
	CString str;
	FieldContentToStrings(nFieldNo, list);
	if (list.IsEmpty())
	{
		return;
	}
	CString strField = FieldToString(nFieldNo);
	POSITION pos = list.GetHeadPosition();
	while (pos)
	{
		str = list.GetNext(pos);
		if (str.IsEmpty())
		{
			continue;
		}
		if (nLine++ == 0)
		{
			AddLine(strField + _T(":"), FALSE);
			AddLine(_T("        ") + str, FALSE);
		}
		else
		{
			AddLine(_T("        ") + str, FALSE);
		}
	}
}

void EkeyNetSdkSampleDlg::OnOK()
{
	int nSel = m_order.GetCurSel();
	if (-1 == nSel)
	{
		return;
	}

	CString displayName, firstName, lastName, desc, path, oid, newName, personalID, company;

	m_editDisplayName.GetWindowText(displayName);
	m_editFirstName.GetWindowText(firstName);
	m_editLastName.GetWindowText(lastName);
	m_editDescription.GetWindowText(desc);
	m_editOid.GetWindowText(oid);
	m_editPath.GetWindowText(path);
	m_editNewName.GetWindowText(newName);
	m_editPersonalID.GetWindowText(personalID);
	m_editCompany.GetWindowText(company);

	static int nLfdNr = 0;
	BYTE cCmd = static_cast<BYTE>(m_order.GetItemData(nSel));
	switch (cCmd)
	{
	case EKEY_NET_CMD_LOGON:         // Logon
		{
			CString user, pwd;
			m_editUserName.GetWindowText(user);
			m_editPwd.GetWindowText(pwd);
			if (user.IsEmpty() || pwd.IsEmpty())
			{
				AfxMessageBox(L"Leeres Feld Benutzer oder leeres Feld Kennwort!", MB_ICONERROR);
				return;
			}
			ekeynet_SetField(EKEY_NET_FIELD_LOGON, user.GetString(), 0);
			ekeynet_SetField(EKEY_NET_FIELD_LOGONPWD, pwd.GetString(), 0);
		}
		break;
	case EKEY_NET_CMD_LOGOFF:         // Logoff
		break;
	case EKEY_NET_CMD_READUSER:         // Read user
		if (!_SetUserLookupFields(oid, displayName, firstName, lastName, personalID))
		{
			AfxMessageBox(L"Ungltige Suchkriterien!", MB_ICONERROR);
			return;
		}
		break;
	case EKEY_NET_CMD_ADDUSER:         // Add user
		if (!firstName.IsEmpty())
		{
			ekeynet_SetField(EKEY_NET_FIELD_FIRSTNAME, firstName.GetString(), 0);
		}
		if (!lastName.IsEmpty())
		{
			ekeynet_SetField(EKEY_NET_FIELD_LASTNAME, lastName.GetString(), 0);
		}
		if (!displayName.IsEmpty())
		{
			ekeynet_SetField(EKEY_NET_FIELD_NAME, displayName.GetString(), 0);
		}
		if (!desc.IsEmpty())
		{
			ekeynet_SetField(EKEY_NET_FIELD_DESC, desc.GetString(), 0);
		}
		break;
	case EKEY_NET_CMD_MODIFYUSER:
		if (!_SetUserLookupFields(oid, displayName, firstName, lastName, personalID))
		{
			AfxMessageBox(L"Ungltige Suchkriterien!", MB_ICONERROR);
			return;
		}
		if (!desc.IsEmpty())
		{
			ekeynet_SetField(EKEY_NET_FIELD_DESC, desc.GetString(), 0);
		}
		break;
	case EKEY_NET_CMD_DELETEUSER:         // Delete user
		if (!_SetUserLookupFields(oid, displayName, firstName, lastName, personalID))
		{
			AfxMessageBox(L"Ungltige Suchkriterien!", MB_ICONERROR);
			return;
		}
		break;
	case EKEY_NET_CMD_ADDUSERTOGROUP:         // Add user to group
		if (!_SetUserLookupFields(oid, displayName, firstName, lastName, personalID))
		{
			AfxMessageBox(L"Ungltige Suchkriterien!", MB_ICONERROR);
			return;
		}
		if (path.IsEmpty())
		{
			AfxMessageBox(L"Ungltiger Pfad fr das Gruppen Objekt!", MB_ICONERROR);
			return;
		}
		ekeynet_SetField(EKEY_NET_FIELD_USERGROUP, path.GetString(), 0);
		break;
	case EKEY_NET_CMD_REMOVEUSERFROMGROUP:
		if (!_SetUserLookupFields(oid, displayName, firstName, lastName, personalID))
		{
			AfxMessageBox(L"Ungltige Suchkriterien!", MB_ICONERROR);
			return;
		}
		if (path.IsEmpty())
		{
			AfxMessageBox(L"Ungltiger Pfad fr das Gruppen Objekt!", MB_ICONERROR);
			return;
		}
		ekeynet_SetField(EKEY_NET_FIELD_USERGROUP, path.GetString(), 0);
		break;
	case EKEY_NET_CMD_ADDUSERTOCOMMONGROUP:
		if (!_SetUserLookupFields(oid, displayName, firstName, lastName, personalID))
		{
			AfxMessageBox(L"Ungltige Suchkriterien!", MB_ICONERROR);
			return;
		}
		break;
	case EKEY_NET_CMD_REMOVEUSERFROMCOMMONGROUP:
		if (!_SetUserLookupFields(oid, displayName, firstName, lastName, personalID))
		{
			AfxMessageBox(L"Ungltige Suchkriterien!", MB_ICONERROR);
			return;
		}
		break;
	case EKEY_NET_CMD_READGROUPS:        // Read groups
		/*Ist mehr als eine Firma vorhanden kann man durch Angabe von EKEY_NET_FIELD_COMPANY auf eine spezifische Firma zugreifen
		  , ansonsten wird die Firma des angemeldeten Benutzers verwendet.*/
		if (!company.IsEmpty())
		{
			ekeynet_SetField(EKEY_NET_FIELD_COMPANY, company.GetString(), 0);
		}
		break;
	case EKEY_NET_CMD_READGROUP:        // Read group
		if (path.IsEmpty())
		{
			AfxMessageBox(L"Kein Pfad fr eine Gruppe angegeben!", MB_ICONERROR);
			return;
		}
		ekeynet_SetField(EKEY_NET_FIELD_USERGROUP, path.GetString(), 0);
		break;
	case EKEY_NET_CMD_ADDGROUP:        // Add group
		if (path.IsEmpty())
		{
			AfxMessageBox(L"Kein Pfad fr eine Gruppe angegeben!", MB_ICONERROR);
			return;
		}
		ekeynet_SetField(EKEY_NET_FIELD_USERGROUP, path.GetString(), 0);
		break;
	case EKEY_NET_CMD_DELETEGROUP:        // Delete group
		if (path.IsEmpty())
		{
			AfxMessageBox(L"Kein Pfad fr eine Gruppe angegeben!", MB_ICONERROR);
			return;
		}
		ekeynet_SetField(EKEY_NET_FIELD_USERGROUP, path.GetString(), 0);
		break;
	case EKEY_NET_CMD_RENAMEGROUP:        // Rename group
		if (path.IsEmpty() || newName.IsEmpty())
		{
			AfxMessageBox(L"Ungltige Parameter!", MB_ICONERROR);
			return;
		}
		ekeynet_SetField(EKEY_NET_FIELD_USERGROUP, path.GetString(), 0);
		ekeynet_SetField(EKEY_NET_FIELD_USERGROUP2, newName.GetString(), 0);
		break;
	case EKEY_NET_CMD_ADDTIMEWINDOW:
		{
			if (!displayName.IsEmpty())
			{
				ekeynet_SetField(EKEY_NET_FIELD_TIMEWINDOW, displayName.GetString(), 0);
			}
			wchar_t timeWindowData01[] = L"6,08:00-12:00";
			int len01 = (wcslen(timeWindowData01) + 1) * sizeof(wchar_t);
			ekeynet_SetField(EKEY_NET_FIELD_TIMEWINDOWDATA, timeWindowData01, len01);

			wchar_t timeWindowData02[] = L"0&1&2&3,08:00-17:00";
			int len02 = (wcslen(timeWindowData02) + 1) * sizeof(wchar_t);
			ekeynet_SetField(EKEY_NET_FIELD_TIMEWINDOWDATA, timeWindowData02, len02);

			wchar_t timeWindowData03[] = L"4,08:00-13:00";
			int len03 = (wcslen(timeWindowData03) + 1) * sizeof(wchar_t);
			ekeynet_SetField(EKEY_NET_FIELD_TIMEWINDOWDATA, timeWindowData03, len03);
		}
		break;
	case EKEY_NET_CMD_READTIMEWINDOW:
		if (displayName.IsEmpty())
		{
			AfxMessageBox(L"Anzeigename ist nicht gesetzt!", MB_ICONERROR);
			return;
		}
		ekeynet_SetField(EKEY_NET_FIELD_TIMEWINDOW, displayName.GetString(), 0);
		break;
	case EKEY_NET_CMD_READTIMEWINDOWS:        // Read time windows
		break;
	case EKEY_NET_CMD_ENABLERCVNOTIFY:        // enable notify
		break;
	case EKEY_NET_CMD_DISABLERCVNOTIFY:        // disable notify
		break;
	case EKEY_NET_CMD_GETCHANGECNT:        // Get Change Count
		break;
	case EKEY_NET_CMD_SENDDATA:
		break;
	}
	ekeynet_SetField(EKEY_NET_FIELD_CMD, &cCmd, 0);
	ekeynet_Write();
}

bool EkeyNetSdkSampleDlg::_SetUserLookupFields(const CString& oid, const CString& dispName, const CString& firstName
		, const CString& lastName, const CString& personalID) const
{
	if (oid.IsEmpty() && dispName.IsEmpty() && (firstName.IsEmpty() || lastName.IsEmpty()) && personalID.IsEmpty())
	{
		AfxMessageBox(L"Keines der Suchkriterien ist gtig!", MB_ICONERROR);
		return false;
	}
	if (!oid.IsEmpty())
	{
		unsigned objId = _wtoi(oid.GetString());
		if (0 == objId)
		{
			AfxMessageBox(L"Das Suchkriterium:Objekt ID ist ungltig!", MB_ICONERROR);
			return false;
		}
		if (!ekeynet_SetField(EKEY_NET_FIELD_OBJECTID, &objId, 0))
		{
			return false;
		}
	}
	if (!dispName.IsEmpty())
	{
		if (!ekeynet_SetField(EKEY_NET_FIELD_NAME, dispName.GetString(), 0))
		{
			return false;
		}
	}
	if (!firstName.IsEmpty() && !lastName.IsEmpty())
	{
		if (!ekeynet_SetField(EKEY_NET_FIELD_FIRSTNAME, firstName.GetString(), 0))
		{
			return false;
		}
		if (!ekeynet_SetField(EKEY_NET_FIELD_LASTNAME, lastName.GetString(), 0))
		{
			return false;
		}
	}
	if (!personalID.IsEmpty())
	{
		if (!ekeynet_SetField(EKEY_NET_FIELD_PERSONALID, personalID.GetString(), 0))
		{
			return false;
		}
	}
	return true;
}

void EkeyNetSdkSampleDlg::FieldContentToStrings(int nFieldNo, CStringList& list)
{
	list.RemoveAll();
	CString str;
	BYTE bBOOL, cByte;
	unsigned int nValue;
	int nValueS, nLen;
	WCHAR szString[256];
	ULONG64 nValue64;
	SYSTEMTIME time;
	switch (nFieldNo)
	{
	case EKEY_NET_FIELD_CMD:
		ekeynet_GetField(nFieldNo, &cByte, sizeof(cByte));
		str = CommandToString(cByte);
		break;
	case EKEY_NET_FIELD_ANSWER:
		ekeynet_GetField(nFieldNo, &cByte, sizeof(cByte));
		switch (cByte)
		{
		case EKEY_NET_EC_NOERROR:
			str = _T("OK");
			break;
		case EKEY_NET_EC_FAILED:
			str = _T("Failed");
			break;
		case EKEY_NET_EC_NOLOGIN:
			str = _T("No Login");
			break;
		case EKEY_NET_EC_EXISTS:
			str = _T("Object already exists");
			break;
		case EKEY_NET_EC_MISSING:
			str = _T("Object is missing");
			break;
		case EKEY_NET_EC_NOTALLOWED:
			str = _T("Command not allowed");
			break;
		case EKEY_NET_EC_UNKNOWN:
			str = _T("Unkown command");
		case EKEY_NET_EC_INVALID_DATA_VERSION:
			str = L"ekeynetsdk.dll version is not compatible with ekey net system";
			break;
		default:
			str.Format(L"Unknown EKEY_NET_FIELD_ANSWER:%u", cByte);
			break;
		}
		break;
	case EKEY_NET_FIELD_LOGON:
	case EKEY_NET_FIELD_LOGONPWD:
	case EKEY_NET_FIELD_COMPANY:
	case EKEY_NET_FIELD_NAME:
	case EKEY_NET_FIELD_FIRSTNAME:
	case EKEY_NET_FIELD_LASTNAME:
	case EKEY_NET_FIELD_DESC:
	case EKEY_NET_FIELD_PERSONALID:
	case EKEY_NET_FIELD_EMAIL:
	case EKEY_NET_FIELD_TELEPHONE:
	case EKEY_NET_FIELD_TELEPHONE2:
	case EKEY_NET_FIELD_ADDRESS:
	case EKEY_NET_FIELD_TITLE:
	case EKEY_NET_FIELD_POSITION:
	case EKEY_NET_FIELD_DEPARTMENT:
	case EKEY_NET_FIELD_SUPERVISOR:
	case EKEY_NET_FIELD_ASSISTANT:
	case EKEY_NET_FIELD_USERDEFINED1:
	case EKEY_NET_FIELD_USERDEFINED2:
	case EKEY_NET_FIELD_USERDEFINED3:
	case EKEY_NET_FIELD_USERDEFINED4:
	case EKEY_NET_FIELD_USERDEFINED5:
	case EKEY_NET_FIELD_USERDEFINED6:
	case EKEY_NET_FIELD_USERDEFINED7:
	case EKEY_NET_FIELD_USERDEFINED8:
	case EKEY_NET_FIELD_USERDEFINED9:
	case EKEY_NET_FIELD_USERDEFINED10:
	case EKEY_NET_FIELD_USERGROUP:
	case EKEY_NET_FIELD_USERGROUP2:
	case EKEY_NET_FIELD_TIMEWINDOW:
		ekeynet_GetField(nFieldNo, &szString, sizeof(szString));
		str = szString;
		break;
	case EKEY_NET_FIELD_VERSION:
	case EKEY_NET_FIELD_OBJECTID:
	case EKEY_NET_FIELD_CHANGECNT:
		ekeynet_GetField(nFieldNo, &nValue, sizeof(nValue));
		str.Format(_T("%d"), nValue);
		break;
	case EKEY_NET_FIELD_STATE:
		ekeynet_GetField(nFieldNo, &bBOOL, sizeof(bBOOL));
		str = (bBOOL) ? _T("Active") : _T("Inactive");
		break;
	case EKEY_NET_FIELD_FINGERMASK:
		ekeynet_GetField(nFieldNo, &nValueS, sizeof(nValueS));
		str.Format(_T("%02x"), nValueS);
		break;
	case EKEY_NET_FIELD_FINGER0:
	case EKEY_NET_FIELD_FINGER1:
	case EKEY_NET_FIELD_FINGER2:
	case EKEY_NET_FIELD_FINGER3:
	case EKEY_NET_FIELD_FINGER4:
	case EKEY_NET_FIELD_FINGER5:
	case EKEY_NET_FIELD_FINGER6:
	case EKEY_NET_FIELD_FINGER7:
	case EKEY_NET_FIELD_FINGER8:
	case EKEY_NET_FIELD_FINGER9:
	case EKEY_NET_FIELD_PHOTO:
	case EKEY_NET_FIELD_RFID:
		nLen = ekeynet_GetField(nFieldNo, m_buffer, sizeof(m_buffer));
		str.Format(_T("Size %d"), nLen);
		break;
	case EKEY_NET_FIELD_TIMEFINGER0:
	case EKEY_NET_FIELD_TIMEFINGER1:
	case EKEY_NET_FIELD_TIMEFINGER2:
	case EKEY_NET_FIELD_TIMEFINGER3:
	case EKEY_NET_FIELD_TIMEFINGER4:
	case EKEY_NET_FIELD_TIMEFINGER5:
	case EKEY_NET_FIELD_TIMEFINGER6:
	case EKEY_NET_FIELD_TIMEFINGER7:
	case EKEY_NET_FIELD_TIMEFINGER8:
	case EKEY_NET_FIELD_TIMEFINGER9:
	case EKEY_NET_FIELD_VALIDFROM:
	case EKEY_NET_FIELD_VALIDTO:
		{
			ekeynet_GetField(nFieldNo, &time, sizeof(SYSTEMTIME));
			COleDateTime t(time);
			if (t.GetStatus() == COleDateTime::valid)
			{
				str = t.Format();
			}
			else
			{
				str = _T("no time");
			}
		}
		break;
	case EKEY_NET_FIELD_WIEGANDID:
		ekeynet_GetField(nFieldNo, &nValue64, sizeof(nValue64));
		str.Format(_T("%I64u"), nValue64);
		break;
	case EKEY_NET_FIELD_USERGROUPS:
	case EKEY_NET_FIELD_TIMEWINDOWS:
	case EKEY_NET_FIELD_TIMEWINDOWDATA:
		{
			ekeynet_GetField(nFieldNo, &m_buffer, sizeof(m_buffer));
			WCHAR* p = (WCHAR*)m_buffer;
			while (*p)
			{
				list.AddTail(p);
				size_t nLen = wcslen(p);
				p += (nLen + 1);
			}
		}
		return;
	case EKEY_NET_FIELD_USERSINGROUP:
		{
			CString str2;
			int nSize = ekeynet_GetField(nFieldNo, &m_buffer, sizeof(m_buffer)) / sizeof(UINT);
			UINT* p = (UINT*)m_buffer;
			for (int i = 0; i < nSize; ++i)
			{
				if (!str.IsEmpty())
				{
					str += _T(",");
				}
				str2.Format(_T("%d"), *p++);
				str += str2;
			}
		}
		break;
	default:
		str.Format(_T("Unkown field %d"), nFieldNo);
		break;
	}
	list.AddTail(str);
}
